package edu.rice.cs.mm.sample;

import edu.rice.cs.mm.*;

public class MultiTest implements MultiTestI {
    @MultiMethod
    public void method(Object o) {
        System.out.println("method(Object o): "+o);
    }
    @MultiMethod
    public void method(Number o) {
        System.out.println("method(Number o): "+o);
    }
    @MultiMethod
    public void method(Comparable o) {
        System.out.println("method(Comparable o): "+o);
    }
    @MultiMethod
    public void method(Integer o) {
        System.out.println("method(Integer o): "+o);
    }
    @MultiMethod
    public void method(String o) {
        System.out.println("method(String o): "+o);
    }
    
    //--------------------
    @MultiMethod
    public void method2(Object o, Object o2) {
        System.out.println("method(Object o, Object o2): "+o+", "+o2);
    }
    @MultiMethod
    public void method2(Number o, Object o2) {
        System.out.println("method(Number o, Object o2): "+o+", "+o2);
    }
    @MultiMethod
    public void method2(Integer o, Object o2) {
        System.out.println("method(Integer o, Object o2): "+o+", "+o2);
    }
    @MultiMethod
    public void method2(String o, Object o2) {
        System.out.println("method(String o, Object o2): "+o+", "+o2);
    }
    //
    @MultiMethod
    public void method2(Object o, Number o2) {
        System.out.println("method(Object o, Number o2): "+o+", "+o2);
    }
    @MultiMethod
    public void method2(Number o, Number o2) {
        System.out.println("method(Number o, Number o2): "+o+", "+o2);
    }
    @MultiMethod
    public void method2(Integer o, Number o2) {
        System.out.println("method(Integer o, Number o2): "+o+", "+o2);
    }
    @MultiMethod
    public void method2(String o, Number o2) {
        System.out.println("method(String o, Number o2): "+o+", "+o2);
    }
    //
    @MultiMethod
    public void method2(Object o, Integer o2) {
        System.out.println("method(Object o, Integer o2): "+o+", "+o2);
    }
    @MultiMethod
    public void method2(Number o, Integer o2) {
        System.out.println("method(Number o, Integer o2): "+o+", "+o2);
    }
    @MultiMethod
    public void method2(Integer o, Integer o2) {
        System.out.println("method(Integer o, Integer o2): "+o+", "+o2);
    }
    @MultiMethod
    public void method2(String o, Integer o2) {
        System.out.println("method(String o, Integer o2): "+o+", "+o2);
    }
    //
    @MultiMethod
    public void method2(Object o, String o2) {
        System.out.println("method(Object o, String o2): "+o+", "+o2);
    }
    @MultiMethod
    public void method2(Number o, String o2) {
        System.out.println("method(Number o, String o2): "+o+", "+o2);
    }
    @MultiMethod
    public void method2(Integer o, String o2) {
        System.out.println("method(Integer o, String o2): "+o+", "+o2);
    }
    @MultiMethod
    public void method2(String o, String o2) {
        System.out.println("method(String o, String o2): "+o+", "+o2);
    }
    
    public static void test(MultiTestI mt) {
        Object o = new Object();
        mt.method(o);
        o = 1;
        mt.method(o);
        o = 1.3;
        mt.method(o);
    }
    
    public static void test2(MultiTestI mt) {
        Object o = new Object();
        Object o2 = new Object();
        mt.method2(o,o2);
        o = 1;
        mt.method2(o,o2);
        o = 1.3;
        mt.method2(o,o2);
        o = new Object();
        o2 = 1;
        mt.method2(o,o2);
        o = 1;
        mt.method2(o,o2);
        o = 1.3;
        mt.method2(o,o2);
        o = new Object();
        o2 = 1.3;
        mt.method2(o,o2);
        o = 1;
        mt.method2(o,o2);
        o = 1.3;
        mt.method2(o,o2);
    }
    
    public static void main(String[] args) {
        MultiTestI mt = new MultiTest();
        test(mt);
        test2(mt);
        mt = MMProxy.newInstance(new MultiTest());
        test(mt);
        test2(mt);
    }
}

interface MultiTestI {
    public void method(Object o);
    public void method(Number o);
    public void method(Comparable o);
    public void method(Integer o);
    public void method(String o);
    //--------------------
    public void method2(Object o, Object o2);
    public void method2(Number o, Object o2);
    public void method2(Integer o, Object o2);
    public void method2(String o, Object o2);
    //
    public void method2(Object o, Number o2);
    public void method2(Number o, Number o2);
    public void method2(Integer o, Number o2);
    public void method2(String o, Number o2);
    //
    public void method2(Object o, Integer o2);
    public void method2(Number o, Integer o2);
    public void method2(Integer o, Integer o2);
    public void method2(String o, Integer o2);
    //
    public void method2(Object o, String o2);
    public void method2(Number o, String o2);
    public void method2(Integer o, String o2);
    public void method2(String o, String o2);
}
